/*
*	ERROR CODES	 
*	200 - 209: openDownload_init
*	210 - 219: openDownloadPrefObserver
*	220 - 229: openDownloadObserver
*/

var openDownload_queue = new Array();

function openDownload_init(){
	try{
		window.removeEventListener("load", openDownload_init, true);
		
		// Add download observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
			observerService.addObserver(openDownloadObserver, "dl-done", false);
			observerService.addObserver(openDownloadObserver, "dl-cancel", false);
			observerService.addObserver(openDownloadObserver, "dl-failed", false);		
		
		// Add pref listener		
		var oPref	= Components.classes["@mozilla.org/preferences;1"].createInstance(Components.interfaces.nsIPrefBranchInternal);
			oPref.addObserver("opendownload.adddownload", openDownloadPrefObserver, false);

	}catch(e){ alert("OpenDownload (200)\nCould not initialize OpenDownload extension.\n"+ e) }
}

const openDownloadPrefObserver = {
	observe : function(subject, topic, data){ 
		try{
			
			var oPref 	= Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefBranch);
			var sPath	= oPref.getCharPref("opendownload.adddownload");
				sPath	= sPath.split("??")[0];
			openDownload_queue[openDownload_queue.length] = sPath;
			
		} catch(e) { alert("OpenDownload (210)\nCould not load file into queue.\n"+ e) }
	}
}

const openDownloadObserver = {
	observe: function (subject, topic, state) {
		var oDownload 	= subject.QueryInterface(Components.interfaces.nsIDownload);
		var oFile	= null;
		
		try{
			oFile = oDownload.targetFile;  // New firefox 0.9
		} catch (e){
			oFile = oDownload.target;      // Old firefox 0.8
		}
		
		if(topic == "dl-cancel" || topic == "dl-failed"){ openDownload_removeFromQueue(oFile.path); }
		else if(topic == "dl-done"){
			
			// File in open queue?
			if(oFile == null || openDownload_inQueue(oFile.path) < 0)
				return;
			else
				openDownload_removeFromQueue(oFile.path);
			
			
			// Execute			
			try{
				if(oFile != null && oFile.exists()){
					oFile.launch();
				}
				else{
					alert("OpenDownload (221)\nCould not open that file.")
				}
			}catch(err){
				alert("OpenDownload (220)\nCould not open that file.\n"+ err)
			}
		}		
	}
}

// Is file in Queue?
//	returns index, or -1
function openDownload_inQueue(sPath){
	for(var i = 0; i < openDownload_queue.length; i++){
		if(openDownload_queue[i] == sPath){
			return i;
		}
	}
	return -1;
}

// Remove file from Queue
function openDownload_removeFromQueue(sPath){
	var index = -1;
	if((index = openDownload_inQueue(sPath)) > -1){
		openDownload_queue = (new Array()).concat(openDownload_queue.slice(0,index), openDownload_queue.slice(++index));
	}
}