/*
*	ERROR CODES	 
*	250 - 259: openDownload_init
* 	260 - 269: openDownload_launch
*	270 - 279: openDownloadPrefObserver
*	270 - 289: openDownloadRdfObserver
*/

var openDownload_queue 	= new Array();
var openDownload_loaded	= false;

function openDownload_init(){
	try{
		window.removeEventListener("load", openDownload_init, true);
		
		if(openDownload_loaded)
			return;
		else
			openDownload_loaded = true;
		
		// Add RDF Listener
		var oIo 		= Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var oProfile	= Components.classes["@mozilla.org/profile/manager;1"].getService(Components.interfaces.nsIProfileInternal);
		var oProfileDir = oIo.newFileURI(oProfile.getProfileDir(oProfile.currentProfile));
		
		var oRdf 		= Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var oDs  		= oRdf.GetDataSourceBlocking("file://" + oProfileDir.path + "downloads.rdf");
			oDs.AddObserver(openDownloadRdfObserver);
		
		// Add pref listener		
		var oPref	= Components.classes["@mozilla.org/preferences;1"].createInstance(Components.interfaces.nsIPrefBranchInternal);
			oPref.addObserver("opendownload.adddownload", openDownloadPrefObserver, false);

	}catch(e){ alert("OpenDownload (250)\nCould not initialize OpenDownload extension.\n"+ e) }
}

// Launch Download
function openDownload_launch(iState, sPath){
	
	if(iState == 1 && openDownload_inQueue(sPath) > -1){
		openDownload_removeFromQueue(sPath);
		
		// Create File
		var oFile = Components.classes["@mozilla.org/file/local;1"].getService(Components.interfaces.nsILocalFile);
			oFile.initWithPath(sPath);
				
		// Execute			
		try{
			if(oFile != null && oFile.exists()){
				oFile.launch();
			}
			else{
				alert("OpenDownload (260)\nCould not open that file.");
			}
		}catch(err){
			alert("OpenDownload (261)\nCould not open that file.\n"+ err);
		}
	}
}

// Preference Listener
const openDownloadPrefObserver = {
	observe : function(subject, topic, data){ 
		try{
			// Get Target Path
			var oPref 	= Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefBranch);
			var sPath	= oPref.getCharPref("opendownload.adddownload");
				sPath	= sPath.split("??")[0];
			openDownload_queue[openDownload_queue.length] = sPath;
			
		} catch(e) { alert("OpenDownload (270)\nCould not load file into queue.\n"+ e) }
	}
}

// Download RDF Observer
const openDownloadRdfObserver = {
	 onAssert : function ( dataSource , source , property , target ){
		try{
			if(property.Value.indexOf("#DownloadState") > -1 && target instanceof Components.interfaces.nsIRDFInt && !isNaN(target.Value)){
				openDownload_launch(parseInt(target.Value), source.Value);
			}
		}catch(e){ }
	 },
	 
	 onBeginUpdateBatch : function ( dataSource ) { },
	 onChange : function ( dataSource , source , property , oldTarget , newTarget ) { 		
		try{					 
			if(property.Value.indexOf("#DownloadState") > -1 && newTarget instanceof Components.interfaces.nsIRDFInt && !isNaN(newTarget.Value)){
				openDownload_launch(parseInt(newTarget.Value), source.Value);
			}
		}catch(e){ }
	 },
	 onEndUpdateBatch : function ( dataSource ) { },
	 onMove : function ( dataSource , oldSource , newSource , property , target  ) { },
	 onUnassert : function ( dataSource , source , property , target ) { }
}

// Is file in Queue?
//	returns index, or -1
function openDownload_inQueue(sPath){
	for(var i = 0; i < openDownload_queue.length; i++){
		if(openDownload_queue[i] == sPath){
			return i;
		}
	}
	return -1;
}

// Remove file from Queue
function openDownload_removeFromQueue(sPath){
	var index = -1;
	if((index = openDownload_inQueue(sPath)) > -1){
		openDownload_queue = (new Array()).concat(openDownload_queue.slice(0,index), openDownload_queue.slice(++index));
	}
}